<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on July 2, 2008 at 6:13:09 pm</time-stamp>


<methods>
<class-id>PROVISO.TupleSubscription</class-id> <category>accessing</category>

<body package="PV-Tuple Storage Engine" selector="firstNeeded:">firstNeeded: aPosition

	| ss pos invalid |
	ss := self sourceStream.
	pos := aPosition.
	invalid := false.
	self critical:
		[(self isValidPosition: aPosition) ifFalse: 
			[self logInvalidFirstNeededSetting: aPosition.
			invalid := true].
		(ss isPosition: aPosition lessThan: firstNeeded) ifTrue: 
			[self logCannotAdjustFirstNeededBackward: aPosition.
			invalid := true].
		invalid ifTrue:
			["Don't raise the exception for now because of what it might do in the context of a CORBA call...if interception is needed, the following is what should be done"
			"pos := [self class invalidFirstNeededPosition raiseRequestWith: (self bestValidFirstNeededPositionFor: pos)]
						on: UnhandledException do: [ :ex | ex parameter parameter]."
			pos := self bestValidFirstNeededPositionFor: pos.
			self logFatalSettingFirstNeededTo: pos insteadOf: aPosition].
		self repository ifNotNil:
			[ :rep |
			rep at: (self name asString, ':firstNeeded') put: pos asString].
		firstNeeded := pos.
		(self sourceStream containerAt: pos) ifNotNil:
			[ :container |
			self filters do: [ :filter | filter advancePast: container timestamp]]].
	self sourceNode scheduleLangoliering.</body>
</methods>

</st-source>
