<?xml version="1.0"?>

<st-source>
<!-- Changes in change set ra503340-pblgenerics -->
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on July 3, 2008 at 4:41:56 pm</time-stamp>


<methods>
<class-id>PROVISO.TupleRepository</class-id> <category>accessing</category>

<body package="PV-CME-Core" selector="specificTimeseriesFor:do:">specificTimeseriesFor: aTimeSeries do: aBlock 
	
	aTimeSeries formula isSpecificToGenericConversion 
		ifFalse: 
			[self pvModel formulaManager 
				formulasWithGenericId: aTimeSeries metricId
				do: 
					[:formula | 
					(self metricTimeSeries 
						atMid: formula id
						rid: aTimeSeries resourceId) ifNotNil: [:specificTs | aBlock value: specificTs]]]</body>
</methods>


<methods>
<class-id>PROVISO.TimeSeries</class-id> <category>builder protocol</category>

<body package="PV-ES-Formulas" selector="disconnect">disconnect

	self removeSpecificToGenericDependency.

	self beImplicit; shouldStore: false.
	super disconnect.</body>

<body package="PV-ES-Formulas" selector="removeSpecificToGenericDependency">removeSpecificToGenericDependency
	"I might be the generic.  If any specific ts point to me because i am generic, then remove me from that dependents collection"
	
	self tupleRepository 
		specificTimeseriesFor: self
		do: [:each | each removeDependent: self]</body>
</methods>

<methods>
<class-id>PROVISO.TimeSeries</class-id> <category>accessing</category>

<body package="PV-ES-Formulas" selector="dependentComputationsDo:">dependentComputationsDo: aBlock 

	self dependents do:
		[:dependent | 
		((dependent isKindOf: FormulaOperator) or: 
			[(dependent isKindOf: PROVISO.PvFormulas.PvCflFormula) or:
				[dependent isKindOf: TimeSeries]])
					ifTrue: [aBlock value: dependent]]</body>
</methods>


<methods>
<class-id>PROVISO.PlanBuilderTimeSeries</class-id> <category>user interface</category>

<body package="PV-DC-Plan-Builder" selector="inspectorChildren">inspectorChildren

	| coll details moreDetails operatorLabel liveTsAssoc |
	details := OrderedCollection new.
	moreDetails := OrderedCollection new.
	moreDetails
		add: (ObjectLabel on: self id formula);
		add: (ObjectLabel on: self id resource).
	coll := self dependentsForTvInspect.
	coll size &gt; 0 
		ifTrue: 
			[moreDetails add: 
				((HierarchicalObjectWrapper 
					key: 'Dependent Computations'
					value: coll)
					inspectorChildren: coll;
					icon: ListIconLibrary collection16x16;
					yourself)].
	self tupleRepository ifNotNil: [:rep | |specificNode|
		rep 
			specificTimeseriesFor: self 
			do: [:eachSpecificTs |
				specificNode := ObjectLabel key: 'Specific: ', eachSpecificTs pvTreeViewLabelString value: eachSpecificTs.
				details add: specificNode]
	].
	self owner 
		ifNotNil: 
			[:operator |
			operatorLabel := ObjectLabel key: 'Operator-', operator pvTreeViewLabelString value: operator.
			(operator respondsTo: #timeSeriesInputsDo:)
				ifTrue: 
					[operator timeSeriesInputsDo: [:input | details add: input].
					moreDetails add: operatorLabel]
				ifFalse: [details add: operatorLabel]].

	coll := self dependentsForTvInspect.
	coll size &gt; 0 
		ifTrue: 
			[moreDetails add: 
				((HierarchicalObjectWrapper 
					key: 'Dependent Computations'
					value: coll)
					inspectorChildren: coll;
					icon: ListIconLibrary collection16x16;
					yourself)].
	
	self streamLabel 
		ifNotNil: 
			[:obj | 
			[liveTsAssoc := self getMyTimeSeries.
			moreDetails add: (ObjectLabel key: liveTsAssoc key value: liveTsAssoc value)] valueQuietly.
			moreDetails add: (ObjectLabel key: 'Label: ' , obj printString value: obj).
			moreDetails asArray].
	details add: 
		((HierarchicalObjectWrapper key: 'More for ', self printString, '...' value: self)
			inspectorChildren: moreDetails asArray;
			icon: ListIconLibrary collection16x16;
			yourself).

	^details asArray</body>
</methods>


<methods>
<class-id>PROVISO.PvFormulaManager</class-id> <category>accessing</category>

<body package="PV-DM-Managers" selector="formulasWithGenericId:do:">formulasWithGenericId: aGenericId do: aBlock 
	
	self itemsDo: 
		[:formula | 
		(formula isSpecificToGenericConversion and: [formula genericId = aGenericId]) 
			ifTrue: [aBlock value: formula]]</body>
</methods>


<methods>
<class-id>PROVISO.CMETimeSeries</class-id> <category>user interface</category>

<body package="PV-CME-Core" selector="inspectorChildren">inspectorChildren

	| coll details moreDetails operatorLabel liveTsAssoc coll1 |
	details := OrderedCollection new.
 	moreDetails := OrderedCollection new.
	moreDetails
		add: (ObjectLabel on: self id formula);
		add: (ObjectLabel on: self id resource).
	self tupleRepository ifNotNil: [:rep | |specificNode|
		rep 
			specificTimeseriesFor: self 
			do: [:eachSpecificTs |
				specificNode := ObjectLabel key: 'Specific: ', eachSpecificTs pvTreeViewLabelString value: eachSpecificTs.
				details add: specificNode]
	].
	self owner 
		ifNotNil: 
			[:operator |
			operatorLabel := ObjectLabel key: 'Operator-', operator pvTreeViewLabelString value: operator.
			(operator respondsTo: #timeSeriesInputsDo:)
				ifTrue: 
					[operator timeSeriesInputsDo: [:input | details add: input].
					moreDetails add: operatorLabel]
				ifFalse: [details add: operatorLabel]].

	coll := self bufferedTuples ifNil: [#()].
	coll isEmpty
		ifTrue: 
			[self owner 
				ifNotNil: 
					[:operator | 
					operator lastTuple 
						ifNotNil: [:tuple | details add: (ObjectLabel key: 'Last record: ', tuple printString)]].
		]
		ifFalse: 
			[coll1 := OrderedCollection new: coll size.
			coll reverseDo: [:eachRec | 
				coll1 add: (ObjectLabel key: eachRec shortDigest value: eachRec)].
			details add: 
				((HierarchicalObjectWrapper 
					key: 'Records: '
					value: coll1)
					inspectorChildren: coll1;
					emphasis: #(veryDarkGray);
					icon: ListIconLibrary collection16x16;
					yourself)].
	" Add reference to the remote original time series if we are not local"
	self isLocalStreamLabel
		ifFalse: 
			[[liveTsAssoc := self getMyTimeSeries.
			details add: (ObjectLabel key: liveTsAssoc key value: liveTsAssoc value)] valueQuietly].

	coll := self dependentsForTvInspect.
	coll size &gt; 0 
		ifTrue: 
			[moreDetails add: 
				((HierarchicalObjectWrapper 
					key: 'Dependent Computations'
					value: coll)
					inspectorChildren: coll;
					icon: ListIconLibrary collection16x16;
					yourself)].
	
	self streamLabel 
		ifNotNil: 
			[:obj | 
			(moreDetails
				add: (ObjectLabel key: 'Label: ' , obj printString value: obj);
				yourself) asArray].
	details add: 
		((HierarchicalObjectWrapper key: 'More for (', self pvTreeViewLabelString, '...', ')' value: self)
			inspectorChildren: moreDetails asArray;
			icon: ListIconLibrary collection16x16;
			emphasis: #(veryDarkGray italic);
			yourself).
	^details asArray</body>
</methods>



</st-source>
