<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.4.1 of May 30, 2006 on July 7, 2008 at 3:22:25 pm</time-stamp>
<!-- Package Changes for PV-DC-Plan-Builder(Kila.87,mkamath)* -->


<methods>
<class-id>PROVISO.PlanBuilder</class-id> <category>plan building</category>

<body package="PV-DC-Plan-Builder" selector="buildPlan:">buildPlan: aBlock 
	"PlanBuilderApplication new startWithCommandLine: 'vm image -a PBL -name PBL -f ../conf/dc.cfg '  "
	
	| hadChanges dl |
	self versionBeingBuilt
		ifNil: [self setAdvancementsForVersionBeingBuilt].
	
	hadChanges := false.
	dl := PblPlanAndMetadataDumperLoader forVersion: self versionBeingBuilt planBuilder: self.
	self initiateCollectorAdvancement.
	self logAboutToUpdatePlan.
	self advancingCollectorLabels isEmpty 
		ifTrue: [self logNoMeaningfulAdvancements]
		ifFalse: 
			[aBlock 
				ifNil: 
					[self updateMetadata: false.
					self buildAndPruneTrees.
					self saveLabelRelationshipsToDatabase.
					hadChanges := self planSaver hasChanges.
					self savePlanToDatabase]
				ifNotNil: 
					[aBlock value.
					hadChanges := self planSaver hasChanges]].
	self completeCollectorAdvancement.
	
	"Save in the main state dir"
	self saveStateLabelChangeHistory.

	"Save all these files in the versionBeingBuilt directory"
	dl
		makeVersionDirectory;
		saveCollectorState;
		saveOperatorState;
		dumpCachedPlanAndMetadata;
		recordPlanRowsInserted: hadChanges.

	"Once we do this it is comitted.  If we don't do this then when PBL 
	restarts we will wipe out the plan and state from disk for the version 
	being built and start over"
	self resetAdvancementsForVersionBeingBuilt.

	"Now that it is committed, go delete big state files from previous versions 
	and make sure we only keep around the most recent N versions of state"
	dl deletePlanAndMetadataFromDiskForAllPreviousVersions.</body>
</methods>

<methods>
<class-id>PROVISO.PlanBuilder</class-id> <category>logging</category>

<body package="PV-DC-Plan-Builder" selector="logNoMeaningfulAdvancements">logNoMeaningfulAdvancements

	self system 
		logInfo: #NO_MEANINGFUL_ADVANCEMENTS
		messageId: nil
		text: 'There were no meaningful collector advancements.  Skipping metadata resync, tree build, db save'.</body>
</methods>


</st-source>
